SystemOrganization addCategory: #OrionGenerator!
SystemOrganization addCategory: #'OrionGenerator-Test'!

TestCase subclass: #ASGeneratorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionGenerator-Test'!

!ASGeneratorTest methodsFor: 'as yet unclassified' stamp: 'AnneEtien 4/3/2013 13:54'!
testCreateASClass
	
	| aGenerator anASClass |
	aGenerator := ASGenerator new.
	anASClass := aGenerator createASClass: FAMIXTestClass.
	self assert: anASClass notNil.
	self assert: (anASClass name) equals: #ASTestClass.
	self assert: (anASClass traitComposition ) equals: #TFAMIXTestClass.
	self assert: (anASClass superclass) equals: #FAMIXTestClass.
	! !

!ASGeneratorTest methodsFor: 'as yet unclassified' stamp: 'AnneEtien 4/3/2013 14:19'!
testCreateASTrait
	
	| aGenerator  aTrait|
	aGenerator := ASGenerator new.
	aTrait := aGenerator createASTrait: FAMIXTestClass .
	self assert: aTrait notNil.
	self assert: (aTrait name) equals: #TFAMIXTestClass.
	self assert: (aTrait traitComposition) equals:  TMooseEntity.
	"self assert: (aTrait traitComposition allTraits contains:  TMooseEntity)"	 "in 2.0"
	! !

!ASGeneratorTest methodsFor: 'as yet unclassified' stamp: 'AnneEtien 4/3/2013 13:47'!
testCreateASTraitExisting
	
	| aGenerator  aTrait|
	aGenerator := ASGenerator new.
	aTrait := aGenerator createASTrait: FAMIXClass .
	self assert: aTrait notNil.
	self assert: (aTrait name) equals: #TFAMIXClass.

	! !

!ASGeneratorTest methodsFor: 'as yet unclassified' stamp: 'AnneEtien 4/3/2013 13:15'!
testCreateClassName
	
	| aGenerator |
	aGenerator := ASGenerator new.
	self assert: (aGenerator createClassName: FAMIXPackage ) equals: #ASPackage.
	! !

!ASGeneratorTest methodsFor: 'as yet unclassified' stamp: 'AnneEtien 4/3/2013 13:14'!
testCreateClassNameNotFamix
	
	| aGenerator |
	aGenerator := ASGenerator new.
	self assert: (aGenerator createClassName: MooseEntity ) equals: #ASMooseEntity.
	! !

!ASGeneratorTest methodsFor: 'as yet unclassified' stamp: 'AnneEtien 4/3/2013 13:17'!
testCreateTraitName
	
	| aGenerator |
	aGenerator := ASGenerator new.
	self assert: (aGenerator createTraitName: FAMIXPackage ) equals: #TFAMIXPackage.
	! !

!ASGeneratorTest methodsFor: 'as yet unclassified' stamp: 'AnneEtien 4/3/2013 13:17'!
testCreateTraitNameNotFamix
	
	| aGenerator |
	aGenerator := ASGenerator new.
	self assert: (aGenerator createTraitName: MooseEntity ) equals: #TMooseEntity.
	! !

Object subclass: #ASGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionGenerator'!

!ASGenerator methodsFor: 'as yet unclassified' stamp: 'AnneEtien 4/3/2013 14:04'!
createASClass: aFamixClass
	"Create an Orion Class corresponding to the FamixClass and inheriting from it"

	| name |
	name := self createClassName: aFamixClass .
	Halt now.
	^Smalltalk globals at: name ifAbsent: [
		aFamixClass  subclass: name
		uses: (self createTraitName: aFamixClass)
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'OrionCore-model']! !

!ASGenerator methodsFor: 'as yet unclassified' stamp: 'AnneEtien 4/3/2013 13:30'!
createASTrait: aFamixClass
	"Create an Orion Class corresponding to the FamixClass and inheriting from it"
	| name |
	name :=  self createTraitName: aFamixClass.
	^Smalltalk globals at: name ifAbsent: [
		Trait named: name
		uses: (self createTraitName: (aFamixClass superclass))
		category: 'OrionCore-model-trait'] .
	! !

!ASGenerator methodsFor: 'as yet unclassified' stamp: 'AnneEtien 4/3/2013 13:14'!
createClassName: aFamixClass
	"Create the name of the Orion Class from the FamixClass"

	| name |

	name := aFamixClass name asString.
	name := (name beginsWith: 'FAMIX') ifTrue:  [name copyAfter: $X]
					ifFalse: [name].
	^ ('AS' , name ) asSymbol ! !

!ASGenerator methodsFor: 'as yet unclassified' stamp: 'AnneEtien 4/3/2013 13:16'!
createTraitName: aFamixClass
	"Create the name of the Orion Class from the FamixClass"

	| name |

	name := aFamixClass name asString.
	^ ('T' , name ) asSymbol ! !
